!------------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム (渦度方程式移流項ヤコビアン計算)
!
!履歴  2016/08/08  竹広真一
!
program ee_mpi_module_jacobianZ_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable  :: vx_Data(:,:)    ! 格子データ
  real(8), allocatable  :: vx_JacobZ(:,:)  ! 格子データ
  real(8), allocatable  :: ef_JacobZ(:,:)  ! 格子データ

  integer, parameter :: k=3,l=1
  integer            :: kk, ll 
  integer            :: np, ip, ierr

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','ee_mpi_module_jacobianZ_test', &
       'ee_mpi_module jacobian function tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  call ee_mpi_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  allocate(vx_Data(jc(ip),0:im-1))    ! 格子データ
  allocate(vx_JacobZ(jc(ip),0:im-1))  ! 格子データ
  allocate(ef_JacobZ(-lm:lm,2*kc(ip)))  ! 格子データ

  !------------------- 初期値設定 ----------------------
  vx_Data = sin(k*pi*vx_X) + cos(l*pi*vx_Y)
!!$  vx_JacobZ = (dble(l)/k-dble(k)/l)*cos(k*pi*vx_X)*sin(l*pi*vx_Y)
  vx_JacobZ = - (dble(l)/k-dble(k)/l)*cos(k*pi*vx_X)*sin(l*pi*vx_Y)

  ef_JacobZ = ef_JacobianZ_ef(ef_vx(vx_Data))
  do kk=1,2*kc(ip)
     do ll=-lm,lm
        if ( abs(ef_JacobZ(ll,kk)) .gt. 1.0D-10 ) then
           write(6,*) ip, ll, kk, ef_JacobZ(ll,kk)
        endif
     enddo
  enddo
  
  call AssertEqual(                                 &
    message = 'JacobZ(sin(k*pi*X)+cos(l*pi*Y))',    &
    answer = vx_JacobZ,                             &
    check = vx_ef(ef_JacobianZ_ef(ef_vx(vx_Data))), &
    significant_digits = check_digits, ignore_digits = ignore     )


  call MPI_FINALIZE(IERR)
  
  call MessageNotify('M','ee_mpi_module_jacobianZ_test', &
       'ee_mpi_module jacobian function tests succeeded!')

end program ee_mpi_module_jacobianZ_test
